"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const MonitoringService = __importStar(require("../services/monitoringService"));
const scheduler_1 = require("./scheduler");
exports.default = {
    name: 'NodeInformationRetrievalJob',
    description: 'Fetches the nodes.json and calculates and stores the monitoring / online status for registered nodes.',
    async run() {
        const result = await MonitoringService.retrieveNodeInformation();
        if (result.failedParsingNodesCount > 0) {
            return scheduler_1.jobResultWarning(`Warning: ${result.failedParsingNodesCount} of ${result.totalNodesCount} nodes could not be processed.`);
        }
        else {
            return scheduler_1.jobResultOkay(`${result.totalNodesCount} nodes have been processed.`);
        }
    },
};
//# sourceMappingURL=NodeInformationRetrievalJob.js.map