"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
require("./init");
const config_1 = require("./config");
const logger_1 = __importDefault(require("./logger"));
const db = __importStar(require("./db/database"));
const scheduler = __importStar(require("./jobs/scheduler"));
const router = __importStar(require("./router"));
const app = __importStar(require("./app"));
app.init();
logger_1.default.init();
logger_1.default.tag('main', 'startup').info('Server starting up...');
async function main() {
    logger_1.default.tag('main').info('Initializing...');
    await db.init();
    scheduler.init();
    router.init();
    app.app.listen(config_1.config.server.port, '::');
}
main()
    .catch(error => {
    console.error('Unhandled runtime error:', error);
    process.exit(1);
});
//# sourceMappingURL=main.js.map